<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditaMoradaAlternativaCliente StructType
 * @subpackage Structs
 */
class EditaMoradaAlternativaCliente extends AbstractStructBase
{
    /**
     * The cliente
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cliente;
    /**
     * The morada
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $morada;
    /**
     * The forceRefresh
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $forceRefresh;
    /**
     * Constructor method for EditaMoradaAlternativaCliente
     * @uses EditaMoradaAlternativaCliente::setCliente()
     * @uses EditaMoradaAlternativaCliente::setMorada()
     * @uses EditaMoradaAlternativaCliente::setForceRefresh()
     * @param string $cliente
     * @param string $morada
     * @param bool $forceRefresh
     */
    public function __construct($cliente = null, $morada = null, $forceRefresh = null)
    {
        $this
            ->setCliente($cliente)
            ->setMorada($morada)
            ->setForceRefresh($forceRefresh);
    }
    /**
     * Get cliente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCliente()
    {
        return isset($this->cliente) ? $this->cliente : null;
    }
    /**
     * Set cliente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cliente
     * @return \StructType\EditaMoradaAlternativaCliente
     */
    public function setCliente($cliente = null)
    {
        // validation for constraint: string
        if (!is_null($cliente) && !is_string($cliente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cliente)), __LINE__);
        }
        if (is_null($cliente) || (is_array($cliente) && empty($cliente))) {
            unset($this->cliente);
        } else {
            $this->cliente = $cliente;
        }
        return $this;
    }
    /**
     * Get morada value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMorada()
    {
        return isset($this->morada) ? $this->morada : null;
    }
    /**
     * Set morada value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $morada
     * @return \StructType\EditaMoradaAlternativaCliente
     */
    public function setMorada($morada = null)
    {
        // validation for constraint: string
        if (!is_null($morada) && !is_string($morada)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($morada)), __LINE__);
        }
        if (is_null($morada) || (is_array($morada) && empty($morada))) {
            unset($this->morada);
        } else {
            $this->morada = $morada;
        }
        return $this;
    }
    /**
     * Get forceRefresh value
     * @return bool|null
     */
    public function getForceRefresh()
    {
        return $this->forceRefresh;
    }
    /**
     * Set forceRefresh value
     * @param bool $forceRefresh
     * @return \StructType\EditaMoradaAlternativaCliente
     */
    public function setForceRefresh($forceRefresh = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceRefresh) && !is_bool($forceRefresh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($forceRefresh)), __LINE__);
        }
        $this->forceRefresh = $forceRefresh;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EditaMoradaAlternativaCliente
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
